<template>
  <div class="task-monitor-gutter">
    <ObLoader
      v-if="isShowLoader"
      class="form-loader"
    />

    <div class="form-title">
      {{ task.type_title }}

      <template v-if="task.participant_title || task.speciesName">
        <router-link
          v-if="task.item_uuid"
          :to="getLink()"
          target="_blank"
        >
          <i
            v-if="task.card_type === 'participant_domain'"
            class="icon role-carrier participant-icon"
          />

          {{ getTaskTitle() }}
        </router-link>

        <template v-else>
          {{ getTaskTitle() }}
        </template>

        {{ task.driver_fio }}

        {{ task.ownerTitle ? 'организации ' + task.ownerTitle : '' }}
      </template>
    </div>

    <div class="form-title-list">
      <template v-for="item of sortedHeaderSections">
        <div
          v-if="item.title && getHeaderValue(item.value)"
          :key="item.uuid"
          class="form-title-list-item"
        >
          <span

            class="form-title-list-item__label"
          >
            {{ item.title }}:
          </span>

          {{ getHeaderValue(item.value) }}
        </div>
      </template>

    </div>

    <ObAlert
      v-if="!isExecutedTask && task.relevance < 0"
      theme="danger"
      icon="alert"
      class="alert-success"
      :hide-close-button="true"
    >
      Задача просрочена
    </ObAlert>

    <ObAlert
      v-if="isExecutedTask"
      theme="success"
      icon="checked"
      class="alert-success"
      :hide-close-button="true"
    >
      Выполнено: {{ task.worker_fio }} {{ parseExecutedDate(task.executed_at) }}
    </ObAlert>
  </div>
</template>

<script>
  import ObLoader from 'common-components/src/obComponents/obLoader'
  import ObAlert from 'common-components/src/obComponents/obAlert'
  import moment from 'moment'

  export default {
    name: 'SectionHeading',
    components: {
      ObLoader,
      ObAlert
    },
    props: {
      task: {
        type: Object,
        required: true
      },
      isShowLoader: {
        type: Boolean,
        required: true
      },
      headerSections: {
        type: Array,
        required: true
      }
    },
    computed: {
      isExecutedTask () {
        return this.task.status.toLowerCase() === 'executed'
      },
      sortedHeaderSections () {
        return this.headerSections ? [...this.headerSections].sort((a, b) => {
          return a.position - b.position
        }) : []
      }
    },
    methods: {
      getLink () {
        let url

        if (this.task.card_type.toLowerCase() === 'resource_domain') {
          if (this.isCarrier) {
            url = '/resources/'
          } else {
            url = '/sb_resource/'
          }
        } else {
          url = '/organizations/'
        }

        return { path: url + this.task.item_uuid }
      },
      getTaskTitle () {
        return `${this.task.participant_title || this.task.speciesName} ${this.task.regNumber || ''}`
      },
      getHeaderValue (value) {
        if (typeof value === 'boolean') {
          return value ? 'Да' : 'Нет'
        } else {
          return value
        }
      },
      parseExecutedDate (date) {
        return moment(date).format('DD.MM.YYYY в HH:mm:ss')
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .form-loader {
    display: flex;
    justify-content: center;
    position: absolute;
    left: 0;
    right: 0;
    z-index: 12;
  }

  .form-title {
    @include font-mixin(24px, 36px, 400, $color-text-base, 0.4px);

    margin-bottom: 20px;

    .participant-icon {
      font-size: 20px;
      margin: 0 1px 0 3px;
    }

    a {
      color: $color-blue-navy-blue;
      text-decoration: none;
    }
  }

  .form-title-list {
    width: 100%;
    margin-bottom: 20px;

    .form-title-list-item {
      @include font-mixin(13px, 20px, 400, $color-text-base, 0.2px);

      width: 50%;
      display: inline-block;

      &__label {
        color: $color-grey-label;
      }
    }
  }

  .alert-success {
    margin-bottom: 30px;
  }
</style>
